#!/usr/bin/env python

class C:
    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self):
        return 4

    def h(self):
        return 5

def test_one(obj):
    obj.f()         # C, D, E -> D
    return obj.g()  # D
    # obj: D

def test_two(obj, obj2):
    if obj.f():     # C, D, E (f)
        obj.g()     # D (f, g)
    # else:
    #   ...         # obj: C, D, E (f)
    #               # (f, g) ^ (f)
    return 2
    # obj: C, D, E (f)

def test_new(obj, obj2):
    if obj.f():     # C, D, E (f)
        obj = obj2
        obj.g()     # D (g)
    # else:
    #   ...         # obj: C, D, E (f)
    #               # (g) ^ (f)
    return obj.f()  # C, D, E (f)
    # obj: C, D, E (f)

def test_neither2(obj, obj2):
    if 0:
        obj.g()     # D (g)
    else:
        obj.f()     # C, D, E (f)
    #               # (g) ^ (f)
    return 4
    # obj:

def test_three(obj, obj2):
    if obj.f():     # C, D, E (f)
        obj = obj2
        obj.g()     # D (g)
    else:
        obj.h()     # E (f, h)
    #               # (g) ^ (f, h)
    return 5
    # obj:

c = C()
d = D()
e = E()
result1_3 = test_one(d)
result1_2 = test_two(c, d)
result2_2 = test_new(c, d)
result1_4 = test_neither2(c, d)
result1_5 = test_three(e, d)

# vim: tabstop=4 expandtab shiftwidth=4
